
function NumberFormat(num,inputDecimal)
{
this.VERSION='Number Format v1.5.4';
this.COMMA=',';
this.PERIOD='.';
this.DASH='-';
this.LEFT_PAREN='(';
this.RIGHT_PAREN=')';
this.LEFT_OUTSIDE=0;
this.LEFT_INSIDE=1;
this.RIGHT_INSIDE=2;
this.RIGHT_OUTSIDE=3;
this.LEFT_DASH=0;
this.RIGHT_DASH=1;
this.PARENTHESIS=2;
this.NO_ROUNDING=-1
this.num;
this.numOriginal;
this.hasSeparators=false;
this.separatorValue;
this.inputDecimalValue;
this.decimalValue;
this.negativeFormat;
this.negativeRed;
this.hasCurrency;
this.currencyPosition;
this.currencyValue;
this.places;
this.roundToPlaces;
this.truncate;
this.setNumber=setNumberNF;
this.toUnformatted=toUnformattedNF;
this.setInputDecimal=setInputDecimalNF;
this.setSeparators=setSeparatorsNF;
this.setCommas=setCommasNF;
this.setNegativeFormat=setNegativeFormatNF;
this.setNegativeRed=setNegativeRedNF;
this.setCurrency=setCurrencyNF;
this.setCurrencyPrefix=setCurrencyPrefixNF;
this.setCurrencyValue=setCurrencyValueNF;
this.setCurrencyPosition=setCurrencyPositionNF;
this.setPlaces=setPlacesNF;
this.toFormatted=toFormattedNF;
this.toPercentage=toPercentageNF;
this.getOriginal=getOriginalNF;
this.moveDecimalRight=moveDecimalRightNF;
this.moveDecimalLeft=moveDecimalLeftNF;
this.getRounded=getRoundedNF;
this.preserveZeros=preserveZerosNF;
this.justNumber=justNumberNF;
this.expandExponential=expandExponentialNF;
this.getZeros=getZerosNF;
this.moveDecimalAsString=moveDecimalAsStringNF;
this.moveDecimal=moveDecimalNF;
this.addSeparators=addSeparatorsNF;
this.dateFormat=dateFormatNF;
this.monnaieFormat=monnaieFormatNF;
this.entierFormat=entierFormat;
this.numberFormat=numberFormat;
if(inputDecimal==null){
this.setNumber(num,this.PERIOD);
}else{
this.setNumber(num,inputDecimal);
}
this.setCommas(true);
this.setNegativeFormat(this.LEFT_DASH);
this.setNegativeRed(false);
this.setCurrency(false);
this.setCurrencyPrefix('$');
this.setPlaces(2);
}
function setInputDecimalNF(val)
{
this.inputDecimalValue=val;
}
function setNumberNF(num,inputDecimal)
{
if(inputDecimal!=null){
this.setInputDecimal(inputDecimal);
}
this.numOriginal=num;
this.num=this.justNumber(num);
}
function toUnformattedNF()
{
return(this.num);
}
function getOriginalNF()
{
return(this.numOriginal);
}
function setNegativeFormatNF(format)
{
this.negativeFormat=format;
}
function setNegativeRedNF(isRed)
{
this.negativeRed=isRed;
}
function setSeparatorsNF(isC,separator,decimal)
{
this.hasSeparators=isC;
if(separator==null)separator=this.COMMA;
if(decimal==null)decimal=this.PERIOD;
if(separator==decimal){
this.decimalValue=(decimal==this.PERIOD)?this.COMMA:this.PERIOD;
}else{
this.decimalValue=decimal;
}
this.separatorValue=separator;
}
function setCommasNF(isC)
{
this.setSeparators(isC,this.COMMA,this.PERIOD);
}
function setCurrencyNF(isC)
{
this.hasCurrency=isC;
}
function setCurrencyValueNF(val)
{
this.currencyValue=val;
}
function setCurrencyPrefixNF(cp)
{
this.setCurrencyValue(cp);
this.setCurrencyPosition(this.LEFT_OUTSIDE);
}
function setCurrencyPositionNF(cp)
{
this.currencyPosition=cp
}
function setPlacesNF(p,tr)
{
this.roundToPlaces=!(p==this.NO_ROUNDING);
this.truncate=(tr!=null&&tr);
this.places=(p<0)?0:p;
}
function addSeparatorsNF(nStr,inD,outD,sep)
{
nStr+='';
var dpos=nStr.indexOf(inD);
var nStrEnd='';
if(dpos!=-1){
nStrEnd=outD+nStr.substring(dpos+1,nStr.length);
nStr=nStr.substring(0,dpos);
}
var rgx=/(\d+)(\d{3})/;
while(rgx.test(nStr)){
nStr=nStr.replace(rgx,'$1'+sep+'$2');
}
return nStr+nStrEnd;
}
function toFormattedNF()
{
var pos;
var nNum=this.num;
var nStr;
var splitString=new Array(2);
if(this.roundToPlaces){
nNum=this.getRounded(nNum);
nStr=this.preserveZeros(Math.abs(nNum));
}else{
nStr=this.expandExponential(Math.abs(nNum));
}
if(this.hasSeparators){
nStr=this.addSeparators(nStr,this.PERIOD,this.decimalValue,this.separatorValue);
}else{
nStr=nStr.replace(new RegExp('\\'+this.PERIOD),this.decimalValue);
}
var c0='';
var n0='';
var c1='';
var n1='';
var n2='';
var c2='';
var n3='';
var c3='';
var negSignL=(this.negativeFormat==this.PARENTHESIS)?this.LEFT_PAREN:this.DASH;
var negSignR=(this.negativeFormat==this.PARENTHESIS)?this.RIGHT_PAREN:this.DASH;
if(this.currencyPosition==this.LEFT_OUTSIDE){
if(nNum<0){
if(this.negativeFormat==this.LEFT_DASH||this.negativeFormat==this.PARENTHESIS)n1=negSignL;
if(this.negativeFormat==this.RIGHT_DASH||this.negativeFormat==this.PARENTHESIS)n2=negSignR;
}
if(this.hasCurrency)c0=this.currencyValue;
}
else if(this.currencyPosition==this.LEFT_INSIDE){
if(nNum<0){
if(this.negativeFormat==this.LEFT_DASH||this.negativeFormat==this.PARENTHESIS)n0=negSignL;
if(this.negativeFormat==this.RIGHT_DASH||this.negativeFormat==this.PARENTHESIS)n3=negSignR;
}
if(this.hasCurrency)c1=this.currencyValue;
}
else if(this.currencyPosition==this.RIGHT_INSIDE){
if(nNum<0){
if(this.negativeFormat==this.LEFT_DASH||this.negativeFormat==this.PARENTHESIS)n0=negSignL;
if(this.negativeFormat==this.RIGHT_DASH||this.negativeFormat==this.PARENTHESIS)n3=negSignR;
}
if(this.hasCurrency)c2=this.currencyValue;
}
else if(this.currencyPosition==this.RIGHT_OUTSIDE){
if(nNum<0){
if(this.negativeFormat==this.LEFT_DASH||this.negativeFormat==this.PARENTHESIS)n1=negSignL;
if(this.negativeFormat==this.RIGHT_DASH||this.negativeFormat==this.PARENTHESIS)n2=negSignR;
}
if(this.hasCurrency)c3=this.currencyValue;
}
nStr=c0+n0+c1+n1+nStr+n2+c2+n3+c3;
if(this.negativeRed&&nNum<0){
nStr='<font color="red">'+nStr+'</font>';
}
return(nStr);
}
function toPercentageNF()
{
nNum=this.num*100;
nNum=this.getRounded(nNum);
return nNum+'%';
}
function getZerosNF(places)
{
var extraZ='';
var i;
for(i=0;i<places;i++){
extraZ+='0';
}
return extraZ;
}
function expandExponentialNF(origVal)
{
if(isNaN(origVal))return origVal;
var newVal=parseFloat(origVal)+'';
var eLoc=newVal.toLowerCase().indexOf('e');
if(eLoc!=-1){
var plusLoc=newVal.toLowerCase().indexOf('+');
var negLoc=newVal.toLowerCase().indexOf('-',eLoc);
var justNumber=newVal.substring(0,eLoc);
if(negLoc!=-1){
var places=newVal.substring(negLoc+1,newVal.length);
justNumber=this.moveDecimalAsString(justNumber,true,parseInt(places));
}else{
if(plusLoc==-1)plusLoc=eLoc;
var places=newVal.substring(plusLoc+1,newVal.length);
justNumber=this.moveDecimalAsString(justNumber,false,parseInt(places));
}
newVal=justNumber;
}
return newVal;
}
function moveDecimalRightNF(val,places)
{
var newVal='';
if(places==null){
newVal=this.moveDecimal(val,false);
}else{
newVal=this.moveDecimal(val,false,places);
}
return newVal;
}
function moveDecimalLeftNF(val,places)
{
var newVal='';
if(places==null){
newVal=this.moveDecimal(val,true);
}else{
newVal=this.moveDecimal(val,true,places);
}
return newVal;
}
function moveDecimalAsStringNF(val,left,places)
{
var spaces=(arguments.length<3)?this.places:places;
if(spaces<=0)return val;
var newVal=val+'';
var extraZ=this.getZeros(spaces);
var re1=new RegExp('([0-9.]+)');
if(left){
newVal=newVal.replace(re1,extraZ+'$1');
var re2=new RegExp('(-?)([0-9]*)([0-9]{'+spaces+'})(\\.?)');
newVal=newVal.replace(re2,'$1$2.$3');
}else{
var reArray=re1.exec(newVal);
if(reArray!=null){
newVal=newVal.substring(0,reArray.index)+reArray[1]+extraZ+newVal.substring(reArray.index+reArray[0].length);
}
var re2=new RegExp('(-?)([0-9]*)(\\.?)([0-9]{'+spaces+'})');
newVal=newVal.replace(re2,'$1$2$4.');
}
newVal=newVal.replace(/\.$/,'');
return newVal;
}
function moveDecimalNF(val,left,places)
{
var newVal='';
if(places==null){
newVal=this.moveDecimalAsString(val,left);
}else{
newVal=this.moveDecimalAsString(val,left,places);
}
return parseFloat(newVal);
}
function getRoundedNF(val)
{
val=this.moveDecimalRight(val);
if(this.truncate){
val=val>=0?Math.floor(val):Math.ceil(val);
}else{
val=Math.round(val);
}
val=this.moveDecimalLeft(val);
return val;
}
function preserveZerosNF(val)
{
var i;
val=this.expandExponential(val);
if(this.places<=0)return val;
var decimalPos=val.indexOf('.');
if(decimalPos==-1){
val+='.';
for(i=0;i<this.places;i++){
val+='0';
}
}else{
var actualDecimals=(val.length-1)-decimalPos;
var difference=this.places-actualDecimals;
for(i=0;i<difference;i++){
val+='0';
}
}
return val;
}
function justNumberNF(val)
{
newVal=val+'';
var isPercentage=false;
if(newVal.indexOf('%')!=-1){
newVal=newVal.replace(/\%/g,'');
isPercentage=true;
}
var re=new RegExp('[^\\'+this.inputDecimalValue+'\\d\\-\\+\\(\\)eE]','g');
newVal=newVal.replace(re,'');
var tempRe=new RegExp('['+this.inputDecimalValue+']','g');
var treArray=tempRe.exec(newVal);
if(treArray!=null){
var tempRight=newVal.substring(treArray.index+treArray[0].length);
newVal=newVal.substring(0,treArray.index)+this.PERIOD+tempRight.replace(tempRe,'');
}
if(newVal.charAt(newVal.length-1)==this.DASH){
newVal=newVal.substring(0,newVal.length-1);
newVal='-'+newVal;
}
else if(newVal.charAt(0)==this.LEFT_PAREN
&&newVal.charAt(newVal.length-1)==this.RIGHT_PAREN){
newVal=newVal.substring(1,newVal.length-1);
newVal='-'+newVal;
}
newVal=parseFloat(newVal);
if(!isFinite(newVal)){
newVal=0;
}
if(isPercentage){
newVal=this.moveDecimalLeft(newVal,2);
}
return newVal;
}
function dateFormat(maDate,formatCible,formatSource)
{
var tabMois=new Array("janv","fvr","mars","avr","mai","juin","juil","aot","sept","oct","nov","dc");
var maDateFormate;
if(formatSource==null)formatSource="DDMMYYYY";
formatSource=formatSource.replace(/J/,"DD");
formatSource=formatSource.replace(/A/,"YYYY");
var regsource="^"+formatSource+"$";
var regJour=regsource;
var regMois=regsource;
var regStMois=regsource;
var regAnnee=regsource;
regsource=regsource.replace(/DD/,"[0-9]{2}");
regJour=regJour.replace(/DD/,"([0-9]{2})");
regMois=regMois.replace(/DD/,"[0-9]{2}");
regStMois=regStMois.replace(/DD/,"[0-9]{2}");
regAnnee=regsource.replace(/DD/,"[0-9]{2}");
regsource=regsource.replace(/MM/,"[0-9]{2}");
regJour=regJour.replace(/MM/,"[0-9]{2}");
regMois=regMois.replace(/MM/,"([0-9]{2})");
regStMois=regStMois.replace(/MM/,"[0-9]{2}");
regAnnee=regAnnee.replace(/MM/,"[0-9]{2}");
regsource=regsource.replace(/mmm/,"[a-zA-Z]{3,4}");
regJour=regJour.replace(/mmm/,"[a-zA-Z]{3,4}");
regMois=regMois.replace(/mmm/,"[a-zA-Z]{3,4}");
regStMois=regStMois.replace(/mmm/,"([a-zA-Z]{3,4})");
regAnnee=regAnnee.replace(/mmm/,"[a-zA-Z]{3,4}");
regsource=regsource.replace(/YYYY/,"[0-9]{4}");
regJour=regJour.replace(/YYYY/,"[0-9]{4}");
regMois=regMois.replace(/YYYY/,"[0-9]{4}");
regStMois=regStMois.replace(/YYYY/,"[0-9]{4}");
regAnnee=regAnnee.replace(/YYYY/,"([0-9]{4})");
regsource=regsource.replace(/YY/,"[0-9]{2}");
regJour=regJour.replace(/YY/,"[0-9]{2}");
regMois=regMois.replace(/YY/,"[0-9]{2}");
regStMois=regStMois.replace(/YY/,"[0-9]{2}");
regAnnee=regAnnee.replace(/YY/,"([0-9]{2})");
rg=new RegExp(regsource,"g");
test=rg.test(maDate);
if(test==false)
return null;
rg=new RegExp(regJour,"g");
rg.exec(maDate);
var jour=RegExp.$1;
rg=new RegExp(regMois,"g");
rg.exec(maDate);
var mois=RegExp.$1;
rg=new RegExp(regStMois,"g");
rg.exec(maDate);
var stMois=RegExp.$1;
if((stMois!=null)&&(stMois!="")){
for(mois=0;mois<12;mois++)
if(tabMois[mois]==stMois)break;
mois++;
if(mois<10)mois="0"+mois;
}
rg=new RegExp(regAnnee,"g");
rg.exec(maDate);
var annee=RegExp.$1;
if(annee<1000)annee+=2000;
var d=new Date(annee,mois-1,jour);
if(isNaN(d)||(d.getDate()!=jour)||((d.getMonth()+1)!=mois))
return null;
formatCible=formatCible.replace(/J/,"DD");
formatCible=formatCible.replace(/A/,"YYYY");
var maDateFormate=formatCible;
maDateFormate=maDateFormate.replace(/DD/,jour);
maDateFormate=maDateFormate.replace(/MM/,mois);
maDateFormate=maDateFormate.replace(/mmm/,tabMois[mois-1]);
maDateFormate=maDateFormate.replace(/YYYY/,annee);
maDateFormate=maDateFormate.replace(/YY/,annee.substring(2,4));
return maDateFormate;
}
function dateFormatNF(maDate,formatCible,formatSource)
{
var tabMois=new Array("janv","fvr","mars","avr","mai","juin","juil","aot","sept","oct","nov","dc");
var maDateFormate;
if(formatSource==null)formatSource="DDMMYYYY";
formatSource=formatSource.replace(/J/,"DD");
formatSource=formatSource.replace(/A/,"YYYY");
var regsource="^"+formatSource+"$";
var regJour=regsource;
var regMois=regsource;
var regStMois=regsource;
var regAnnee=regsource;
regsource=regsource.replace(/DD/,"[0-9]{2}");
regJour=regJour.replace(/DD/,"([0-9]{2})");
regMois=regMois.replace(/DD/,"[0-9]{2}");
regStMois=regStMois.replace(/DD/,"[0-9]{2}");
regAnnee=regsource.replace(/DD/,"[0-9]{2}");
regsource=regsource.replace(/MM/,"[0-9]{2}");
regJour=regJour.replace(/MM/,"[0-9]{2}");
regMois=regMois.replace(/MM/,"([0-9]{2})");
regStMois=regStMois.replace(/MM/,"[0-9]{2}");
regAnnee=regAnnee.replace(/MM/,"[0-9]{2}");
regsource=regsource.replace(/mmm/,"[a-zA-Z]{3,4}");
regJour=regJour.replace(/mmm/,"[a-zA-Z]{3,4}");
regMois=regMois.replace(/mmm/,"[a-zA-Z]{3,4}");
regStMois=regStMois.replace(/mmm/,"([a-zA-Z]{3,4})");
regAnnee=regAnnee.replace(/mmm/,"[a-zA-Z]{3,4}");
regsource=regsource.replace(/YYYY/,"[0-9]{4}");
regJour=regJour.replace(/YYYY/,"[0-9]{4}");
regMois=regMois.replace(/YYYY/,"[0-9]{4}");
regStMois=regStMois.replace(/YYYY/,"[0-9]{4}");
regAnnee=regAnnee.replace(/YYYY/,"([0-9]{4})");
regsource=regsource.replace(/YY/,"[0-9]{2}");
regJour=regJour.replace(/YY/,"[0-9]{2}");
regMois=regMois.replace(/YY/,"[0-9]{2}");
regStMois=regStMois.replace(/YY/,"[0-9]{2}");
regAnnee=regAnnee.replace(/YY/,"([0-9]{2})");
rg=new RegExp(regsource,"g");
test=rg.test(maDate);
if(test==false)
return null;
rg=new RegExp(regJour,"g");
rg.exec(maDate);
var jour=RegExp.$1;
rg=new RegExp(regMois,"g");
rg.exec(maDate);
var mois=RegExp.$1;
rg=new RegExp(regStMois,"g");
rg.exec(maDate);
var stMois=RegExp.$1;
if((stMois!=null)&&(stMois!="")){
for(mois=0;mois<12;mois++)
if(tabMois[mois]==stMois)break;
mois++;
if(mois<10)mois="0"+mois;
}
rg=new RegExp(regAnnee,"g");
rg.exec(maDate);
var annee=RegExp.$1;
if(annee<1000)annee+=2000;
var d=new Date(annee,mois-1,jour);
if(isNaN(d)||(d.getDate()!=jour)||((d.getMonth()+1)!=mois))
return null;
formatCible=formatCible.replace(/J/,"DD");
formatCible=formatCible.replace(/A/,"YYYY");
var maDateFormate=formatCible;
maDateFormate=maDateFormate.replace(/DD/,jour);
maDateFormate=maDateFormate.replace(/MM/,mois);
maDateFormate=maDateFormate.replace(/mmm/,tabMois[mois-1]);
maDateFormate=maDateFormate.replace(/YYYY/,annee);
maDateFormate=maDateFormate.replace(/YY/,annee.substring(2,4));
return maDateFormate;
}
function monnaieFormatNF(monChiffre,devise)
{
var num=new NumberFormat();
num.setInputDecimal('.');
num.setPlaces('2',false);
num.setCurrencyValue((devise==null)?"":" "+devise);
num.setCurrency(true);
num.setCurrencyPosition(num.RIGHT_OUTSIDE);
num.setNegativeFormat(num.LEFT_DASH);
num.setNegativeRed(false);
num.setSeparators(true,' ',' ');
num.setNumber(monChiffre);
return num.toFormatted().replace(".",",");
}
function monnaieFormat(monChiffre,devise)
{
var num=new NumberFormat();
num.setInputDecimal('.');
num.setPlaces('2',false);
num.setCurrencyValue((devise==null)?"":" "+devise);
num.setCurrency(true);
num.setCurrencyPosition(num.RIGHT_OUTSIDE);
num.setNegativeFormat(num.LEFT_DASH);
num.setNegativeRed(false);
num.setSeparators(true,' ',' ');
num.setNumber(monChiffre);
return num.toFormatted().replace(".",",");
}
function entierFormatNF(monChiffre)
{
var num=new NumberFormat();
num.setPlaces('0',false);
num.setCurrencyValue('');
num.setCurrency(true);
num.setCurrencyPosition(num.RIGHT_OUTSIDE);
num.setNegativeFormat(num.LEFT_DASH);
num.setNegativeRed(false);
num.setSeparators(true,' ',' ');
num.setNumber(monChiffre);
return num.toFormatted();
}
function entierFormat(monChiffre)
{
var num=new NumberFormat();
num.setPlaces('0',false);
num.setCurrencyValue('');
num.setCurrency(true);
num.setCurrencyPosition(num.RIGHT_OUTSIDE);
num.setNegativeFormat(num.LEFT_DASH);
num.setNegativeRed(false);
num.setSeparators(true,' ',' ');
num.setNumber(monChiffre);
return num.toFormatted();
}
function numberFormat(monChiffre,formatCible)
{
if(isNaN(monChiffre)){
monChiffre=parseFloat(monChiffre.replace(",","."));
if(isNaN(monChiffre))return null;
}
switch(formatCible){
case "ENTIER":
return entierFormat(monChiffre);
break;
case "MONNAIE":
return monnaieFormat(monChiffre);
break;
case "EURO":
return monnaieFormat(monChiffre,"&#8364;");
break;
default:
return null;
}
}
function NombreFormate(unNombre,uneExpressionFormatage){
this.SEPARATEUR="|";
this.EXPREG=/^\[[^||]*[||]?[^||]*\]\[[^||]*[||]?[^||]*\]\[[^||]*[||]?[^||]*\]\[[^||]*[||]?[^||]*\]\[([0-9].[0-9])?[\+|-]?[||][0-9]?[||][^||]*[||][^||]*[||][0-4]?[||][^||]*[||][N|S]?\]$/;
this.TYPEARRONDIDEF="";
this.SEUILARRONDIDEF=0.5;
this.NBDECIMALDEF=0;
this.SEPARATEURDECIMALDEF=",";
this.SYMBOLDEF="";
this.POSSYMBOLDEF="4";
this.FACTEURCONVERSIONDEF=1;
this.FORMATAFFICHAGEDEF="N";
this.FPDECNEG="";
this.FPDEC="";
this.FPENTNEG="";
this.FPENT="";
this.positif=true;
this.nombre=unNombre;
this.nombreNormalise="";
this.nombreFormate="";
this.expressionFormatage=uneExpressionFormatage;
this.partieEntiere="";
this.partieEntiereFormate="";
this.partieDecimale="";
this.partieDecimaleFormate="";
this.prefixe="";
this.prefixeNegatif="";
this.postfixe="";
this.postfixeNegatif="";
this.formatPartieEntiere=this.FPENT;
this.formatPartieEntiereNegatif=this.FPENTNEG;
this.formatPartieDecimale=this.FPDEC;
this.formatPartieDecimaleNegatif=this.FPDECNEG;
this.seuilArrondi=this.SEUILARRONDIDEF;
this.typeArrondi=this.TYPEARRONDIDEF;
this.nbDecimale=this.NBDECIMALDEF;
this.separateur=this.SEPARATEURDECIMALDEF;
this.symbol=this.SYMBOLDEF;
this.posSymbol=this.POSSYMBOLDEF;
this.facteurConversion=this.FACTEURCONVERSIONDEF;
this.formatAffichage=this.FORMATAFFICHAGEDEF;
this.puissancesE="";
this.estExpressionCorrecte=function(){
return this.EXPREG.test(this.expressionFormatage);
}
this.estNombrePositif=function(){
return(this.positif);
}
this.donneNombreFormate=function(){
if(this.nombre=="")
return false;
if(isNaN(this.nombre)){
this.nombre=this.nombre.replace(",",".");
if(isNaN(this.nombre))
return false;
}
this.nombreNormalise=this.nombre;
if(this.nombreNormalise<0){
this.positif=false;
this.nombreNormalise=this.nombreNormalise*(-1);
}
this.initPrefixe();
this.initPostfixe();
this.initPartieEntiere();
this.initPartieDecimale();
this.initOptions();
this.factoriserNombre();
this.formaterAffichage();
this.arrondirNombre();
this.initNombre();
this.formaterPartieEntiere();
if(this.partieDecimale!="")
this.formaterPartieDecimale();
var valeur="";
var estPositif=this.estNombrePositif();
valeur+=((this.symbol!=""&&this.posSymbol=="0")?this.symbol:"");
valeur+=((estPositif)?this.prefixe:this.prefixeNegatif);
valeur+=((this.symbol!=""&&this.posSymbol=="1")?this.symbol:"");
valeur+=this.partieEntiereFormate;
valeur+=((this.symbol!=""&&this.posSymbol=="2")?this.symbol:"");
valeur+=((this.partieDecimale!="")?this.separateur:"");
valeur+=((this.partieDecimale!="")?this.partieDecimaleFormate:"");
valeur+=((this.formatAffichage=="S")?"E"+this.puissancesE:"");
valeur+=((this.symbol!=""&&this.posSymbol=="3")?this.symbol:"");
valeur+=((estPositif)?this.postfixe:this.postfixeNegatif);
valeur+=((this.symbol!=""&&this.posSymbol=="4")?this.symbol:"");
this.nombreFormate=valeur;
return valeur;
}
this.donneOrigineNombreFormate=function(resultatFormate){
this.nombreFormate=resultatFormate;
this.initPrefixe();
this.initPostfixe();
this.initPartieEntiere();
this.initPartieDecimale();
this.initOptions();
if((this.prefixeNegatif!=""&&this.nombreFormate.indexOf(this.prefixeNegatif)!=-1)
||(this.nombreFormate.indexOf(this.postfixeNegatif)!=-1&&this.postfixeNegatif!=""))
this.positif=false;
var estDecimal=false;
if(this.nombreFormate.indexOf(this.separateur)!=-1)
estDecimal=true;
this.extrairePartieEntiere();
if(estDecimal)
this.extrairePartieDecimale();
this.nombreNormalise=((this.positif)?"":"-")+this.partieEntiere+"."+this.partieDecimale;
this.nombreNormalise=parseFloat(this.nombreNormalise);
if(this.puissancesE!="")
if(this.puissancesE.charAt(0)=="+")
this.nombreNormalise=this.nombreNormalise*Math.pow(10,parseInt(this.puissancesE.substring(1,this.puissancesE.length)));
else
this.nombreNormalise=this.nombreNormalise/Math.pow(10,parseInt(this.puissancesE.substring(1,this.puissancesE.length)));
this.nombreNormalise=this.nombreNormalise/this.facteurConversion;
if(this.typeArrondi=="+")
this.typeArrondi="-";
else
this.typeArrondi="+";
this.arrondirNombre();
return this.nombreNormalise;
}
this.extrairePartieDecimale=function(){
var posDebDecimal=0;
var posFinDecimal=0;
var estPositif=this.estNombrePositif();
posDebDecimal=this.nombreFormate.indexOf(this.separateur)+1;
if(this.formatAffichage=="S"){
posFinDecimal=((this.nombreFormate.indexOf("E+")==-1)?this.nombreFormate.indexOf("E-"):this.nombreFormate.indexOf("E+"));
this.extrairePuissance();
}else
posFinDecimal=this.nombreFormate.length-((estPositif)?this.postfixe.length:this.postfixeNegatif.length)-((this.posSymbol=="3"||this.posSymbol=="4")?this.symbol.length:0);
if(posDebDecimal>=posFinDecimal){
this.partieDecimale=0;
return;
}
var index=posDebDecimal;
var carCourant="";
this.partieDecimale="";
while(index!=posFinDecimal){
carCourant=this.nombreFormate.charAt(index);
if(carCourant.search(/[0-9]/)!=-1)
this.partieDecimale=this.partieDecimale+carCourant;
index++;
}
}
this.extrairePartieEntiere=function(){
var posDebEntier=0;
var posFinEntier=0;
var estPositif=this.estNombrePositif();
if(this.symbol!=""&&this.posSymbol=="0")
posDebEntier+=this.symbol.length;
if(estPositif)
posDebEntier+=this.prefixe.length;
else
posDebEntier+=this.prefixeNegatif.length;
if(this.symbol!=""&&this.posSymbol=="1")
posDebEntier+=this.symbol.length;
var posSeparateur=this.nombreFormate.indexOf(this.separateur);
if(posSeparateur!=-1){
posFinEntier=posSeparateur;
if(this.symbol!=""&&this.posSymbol=="2")
posFinEntier-=this.symbol.length;
}else{
if(this.formatAffichage=="S"){
posFinEntier=((this.nombreFormate.indexOf("E+")==-1)?this.nombreFormate.indexOf("E-"):this.nombreFormate.indexOf("E+"));
this.extrairePuissance();
}else
posFinEntier=this.nombreFormate.length-((estPositif)?this.postfixe.length:this.postfixeNegatif.length)-((this.posSymbol=="2"||this.posSymbol=="3"||this.posSymbol=="4")?this.symbol.length:0);
}
if(posDebEntier>=posFinEntier){
this.partieEntiere=0;
return;
}
var index=posDebEntier;
var carCourant="";
this.partieEntiere="";
while(index!=posFinEntier){
carCourant=this.nombreFormate.charAt(index);
if(carCourant.search(/[0-9]/)!=-1)
this.partieEntiere=this.partieEntiere+carCourant;
index++;
}
}
this.extrairePuissance=function(){
var index;
var carCourant="";
this.puissancesE="";
if(this.nombreFormate.indexOf("E+")==-1){
index=this.nombreFormate.indexOf("E-")+2;
this.puissancesE="-";
}else{
index=this.nombreFormate.indexOf("E+")+2;
this.puissancesE="+";
}
while(index<this.nombreFormate.length){
carCourant=this.nombreFormate.charAt(index);
if(carCourant.search(/[0-9]+/)!=-1)
this.puissancesE=this.puissancesE+carCourant;
else
break;
index++;
}
}
this.initPrefixe=function(){
var tableauExpReg=this.expressionFormatage.split("][");
var posSeparateur;
if(tableauExpReg[0].length-1!=0){
posSeparateur=tableauExpReg[0].indexOf(this.SEPARATEUR);
if(posSeparateur!=-1){
this.prefixe=tableauExpReg[0].slice(1,posSeparateur);
this.prefixeNegatif=tableauExpReg[0].slice(posSeparateur+1,tableauExpReg[0].length);
}else{
this.prefixe=tableauExpReg[0].slice(1,tableauExpReg[0].length);
this.prefixeNegatif=this.prefixe;
}
}
}
this.initPostfixe=function(){
var tableauExpReg=this.expressionFormatage.split("][");
var posSeparateur;
if(tableauExpReg[3].length!=0){
posSeparateur=tableauExpReg[3].indexOf(this.SEPARATEUR);
if(posSeparateur!=-1){
this.postfixe=tableauExpReg[3].slice(0,posSeparateur);
this.postfixeNegatif=tableauExpReg[3].slice(posSeparateur+1,tableauExpReg[3].length);
}else{
this.postfixe=tableauExpReg[3].slice(0,tableauExpReg[3].length);
this.postfixeNegatif=this.postfixe;
}
}
}
this.initPartieEntiere=function(){
var tableauExpReg=this.expressionFormatage.split("][");
var posSeparateur;
if(tableauExpReg[1].length!=0){
posSeparateur=tableauExpReg[1].indexOf(this.SEPARATEUR);
if(posSeparateur!=-1){
this.formatPartieEntiere=tableauExpReg[1].slice(0,posSeparateur);
this.formatPartieEntiereNegatif=tableauExpReg[1].slice(posSeparateur+1,tableauExpReg[1].length);
}else{
this.formatPartieEntiere=tableauExpReg[1].slice(0,tableauExpReg[1].length);
this.formatPartieEntiereNegatif=this.formatPartieEntiere;
}
}
}
this.initPartieDecimale=function(){
var tableauExpReg=this.expressionFormatage.split("][");
var posSeparateur;
if(tableauExpReg[2].length!=0){
posSeparateur=tableauExpReg[2].indexOf(this.SEPARATEUR);
if(posSeparateur!=-1){
this.formatPartieDecimale=tableauExpReg[2].slice(0,posSeparateur);
this.formatPartieDecimaleNegatif=tableauExpReg[2].slice(posSeparateur+1,tableauExpReg[2].length);
}else{
this.formatPartieDecimale=tableauExpReg[2].slice(0,tableauExpReg[2].length);
this.formatPartieDecimaleNegatif=this.formatPartieEntiere;
}
}
}
this.initOptions=function(){
var tableauExpReg=this.expressionFormatage.split("][");
var options;
var tableauOptions;
options=tableauExpReg[4].slice(0,tableauExpReg[4].length-1);
tableauOptions=options.split("|");
if(tableauOptions[0]!=""){
if(tableauOptions[0].indexOf("+")==-1&&tableauOptions[0].indexOf("-")==-1){
this.typeArrondi="";
this.seuilArrondi=0;
}else{
if(tableauOptions[0].length!=1){
this.seuilArrondi=tableauOptions[0].slice(0,tableauOptions[0].length-1);
this.typeArrondi=tableauOptions[0].slice(tableauOptions[0].length-1,tableauOptions[0].length);
}else{
this.typeArrondi=tableauOptions[0];
}
}
}
this.nbDecimale=(tableauOptions[1]!="")?tableauOptions[1]:this.nbDecimale;
this.separateur=(tableauOptions[2]!="")?tableauOptions[2]:this.separateur;
this.symbol=(tableauOptions[3]!="")?tableauOptions[3]:this.symbol;
this.posSymbol=(tableauOptions[4]!="")?tableauOptions[4]:this.posSymbol;
this.facteurConversion=(tableauOptions[5]!="")?tableauOptions[5]:this.facteurConversion;
this.formatAffichage=(tableauOptions[6]!="")?tableauOptions[6]:this.formatAffichage;
}
this.initNombre=function(){
var chaineNormalise=this.nombreNormalise+"";
var posSeparateur=chaineNormalise.indexOf(".");
if(posSeparateur!=-1){
this.partieEntiere=chaineNormalise.slice(0,posSeparateur);
this.partieDecimale=chaineNormalise.slice(posSeparateur+1,chaineNormalise.length);
}else this.partieEntiere=chaineNormalise;
}
this.formaterPartieEntiere=function(){
var motifEnCours="";
if((this.formatPartieEntiere==""&&this.formatPartieEntiereNegatif=="")
||(this.estNombrePositif()&&this.formatPartieEntiere=="")
||(!this.estNombrePositif()&&this.formatPartieEntiereNegatif=="")){
this.partieEntiereFormate=this.partieEntiere;
return;
}
if(this.estNombrePositif())
motifEnCours=this.formatPartieEntiere;
else
motifEnCours=this.formatPartieEntiereNegatif;
var indexNombre=0;
var lgNombre=this.partieEntiere.length;
var indexMotif=0;
var lgMotif=motifEnCours.length;
var sortie="";
while(indexNombre<lgNombre){
if(motifEnCours.charAt(lgMotif-1-indexMotif)!="0")
sortie=motifEnCours.charAt(lgMotif-1-indexMotif)+sortie;
else{
sortie=this.partieEntiere.charAt(lgNombre-1-indexNombre)+sortie;
indexNombre++;
}
indexMotif++;
if(indexMotif==lgMotif-1)
indexMotif=0;
}
this.partieEntiereFormate=sortie;
}
this.formaterPartieDecimale=function(){
var motifEnCours="";
if((this.formatPartieDecimale==""&&this.formatPartieDecimaleNegatif=="")
||(this.estNombrePositif()&&this.formatPartieDecimale=="")
||(!this.estNombrePositif()&&this.formatPartieDecimaleNegatif=="")){
this.partieDecimaleFormate=this.partieDecimale;
return;
}
if(this.estNombrePositif())
motifEnCours=this.formatPartieDecimale;
else
motifEnCours=this.formatPartieDecimaleNegatif;
var indexNombre=0;
var lgNombre=this.partieDecimale.length;
var indexMotif=0;
var lgMotif=motifEnCours.length;
var sortie="";
while(indexNombre<lgNombre){
if(motifEnCours.charAt(lgMotif-1-indexMotif)!="0")
sortie=sortie+motifEnCours.charAt(lgMotif-1-indexMotif);
else{
sortie=sortie+this.partieDecimale.charAt(indexNombre);
indexNombre++;
}
indexMotif++;
if(indexMotif==lgMotif-1)
indexMotif=0;
}
this.partieDecimaleFormate=sortie;
}
this.factoriserNombre=function(){
this.nombreNormalise=this.nombreNormalise*this.facteurConversion;
}
this.arrondirNombre=function(){
if(this.nombreNormalise-Math.floor(this.nombreNormalise)==0)
return;
if(this.typeArrondi=="")
{
if(this.nbDecimale==0)
this.nombreNormalise=Math.floor(this.nombreNormalise);
else{
var entier=Math.floor(this.nombreNormalise);
var multiple=Math.pow(10,parseInt(this.nbDecimale));
var decimales=(this.nombreNormalise-Math.floor(this.nombreNormalise))*multiple;
this.nombreNormalise=""+entier+"."+Math.floor(decimales);
}
}else{
var multiple=Math.pow(10,parseInt(this.nbDecimale)+1);
var mille=multiple*this.nombreNormalise;
var entier=Math.floor(mille);
var reste=entier%10;
var signe=(this.positif)?1:-1;
if(((reste<(parseFloat(this.seuilArrondi)*10*signe))&&this.typeArrondi=="+")
||((reste<=(parseFloat(this.seuilArrondi)*10*signe))&&this.typeArrondi=="-"))
entier=(entier-reste)/10;
else
entier=((entier-reste)/10)+1;
this.nombreNormalise=""+(entier/(multiple/10));
}
}
this.formaterAffichage=function(){
this.puissancesE="";
if(this.formatAffichage=="S"){
var entier=Math.floor(this.nombreNormalise)+"";
var nbMaxEntier=((this.estNombrePositif())?1:2);
if((nbMaxEntier==1&&entier=="0")||(nbMaxEntier==2&&entier=="-0")){
while(entier=="0"||entier=="-0"){
this.nombreNormalise=this.nombreNormalise*10;
entier=Math.floor(this.nombreNormalise)+"";
this.puissancesE--;
}
}else{
while(entier.length!=nbMaxEntier){
this.nombreNormalise=this.nombreNormalise/10;
entier=Math.floor(this.nombreNormalise)+"";
this.puissancesE++;
}
}
}
if(this.puissancesE<0)
this.puissancesE=this.puissancesE+"";
else
this.puissancesE="+"+this.puissancesE;
}
}
function formaterNombre(nombre,expressionFormatage)
{
var monNombre=new NombreFormate(nombre,expressionFormatage);
if(!monNombre.estExpressionCorrecte())
return false;
return monNombre.donneNombreFormate();
}
function deformaterNombre(nombreFormate,expressionFormatage)
{
var monNombre=new NombreFormate(null,expressionFormatage);
if(!monNombre.estExpressionCorrecte())
return false;
return monNombre.donneOrigineNombreFormate(nombreFormate);
}
