<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:strip-space elements="*"/>
	<xsl:output method="xml" encoding="ISO-8859-1" standalone="yes" indent="no"/>


	<xsl:template match="/root/data">
		<HTML>
			<HEAD>
				<TITLE>Erreur</TITLE>
			</HEAD>
			<BODY>
				<xsl:for-each select="ErrorVO">
					<xsl:variable name="cd_erreur" select="cdError"/>
					<xsl:variable name="paramLabel" select="paramLabel"/>
					<xsl:variable name="paramNota" select="paramNota"/>
					<H1>Erreur <xsl:value-of select="$cd_erreur"/></H1>
					<xsl:for-each select="/root/resourcesproperties/error/ERR">
						<xsl:variable name="code" select="CODE"/>
						<xsl:if test="$code = $cd_erreur">
							<H2>
								<xsl:variable name="libelle" select="LIBELLE"/>
								<xsl:choose>
									<xsl:when test="contains($libelle,'%1')">
										<xsl:value-of select="concat(substring-before($libelle,'%1'),$paramLabel,substring-after($libelle,'%1'))"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="$libelle"/>
									</xsl:otherwise>
								</xsl:choose>
							</H2>
							<H2>
								<xsl:variable name="nota" select="NOTA"/>
								<xsl:choose>
									<xsl:when test="contains($nota,'%1')">
										<xsl:value-of select="concat(substring-before($nota,'%1'),$paramNota,substring-after($nota,'%1'))"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="$nota"/>
									</xsl:otherwise>
								</xsl:choose>
							</H2>
						</xsl:if>
					</xsl:for-each>
				</xsl:for-each>
			</BODY>
		</HTML>
	</xsl:template>

	<xsl:template match="class"/>
	<xsl:template match="title"/>
	<xsl:template match="error"/>
	<xsl:template match="root/resourcesproperties"/>
	<xsl:template match="root/erreurs"/>
	<xsl:template match="root/request"/>
	<xsl:template match="root/session"/>
	<xsl:template match="root/actionform"/>
	<xsl:template match="root/variables"/>

</xsl:stylesheet>
