<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:strip-space elements="*"/>
<xsl:output method="xml" encoding="ISO-8859-1" standalone="yes" indent="no"/>


	<xsl:template match="/root/data">
	  <LISTE_ERREURS>
		<xsl:for-each select="ErrorVO">
		  <ERREUR>
		  	<xsl:variable name="cd_erreur" select="cdError" />
				<xsl:for-each select="/root/resourcesproperties/error/ERR">
					<xsl:if test="CODE = $cd_erreur">
						<CODE><xsl:value-of select="CODE" /></CODE>
						<LIBELLE><xsl:value-of select="LIBELLE" /></LIBELLE>
						<NOTA><xsl:value-of select="NOTA" /></NOTA>
				    </xsl:if>
				</xsl:for-each>
		  	<LISTE_PARAM_LIBELLE><xsl:value-of select="paramLabel" /></LISTE_PARAM_LIBELLE>
		  	<LISTE_PARAM_NOTA><xsl:value-of select="paramNota" /></LISTE_PARAM_NOTA>
		    <xsl:variable name="bl_faq" select="faq" />
		    <xsl:choose>
		      <xsl:when test="$bl_faq = 'true'">
		        <FAQ>OUI</FAQ>
		      </xsl:when>
		      <xsl:otherwise>
		        <FAQ>NON</FAQ>
		      </xsl:otherwise>
		    </xsl:choose>
		    <xsl:variable name="bl_aide" select="aide" />
		    <xsl:choose>
		      <xsl:when test="$bl_aide = 'true'">
		        <AIDE>OUI</AIDE>
		      </xsl:when>
		      <xsl:otherwise>
		        <AIDE>NON</AIDE>
		      </xsl:otherwise>
		    </xsl:choose>
		    <xsl:variable name="bl_mailto" select="mailTo" />
		    <xsl:choose>
		      <xsl:when test="$bl_mailto = 'true'">
		        <MAILTO><xsl:value-of select="/root/resourcesproperties/mailto" /></MAILTO>
		      </xsl:when>
		      <xsl:otherwise>
		        <MAILTO></MAILTO>
		      </xsl:otherwise>
		    </xsl:choose>
		  </ERREUR>
		</xsl:for-each>
	  </LISTE_ERREURS>
	</xsl:template>

	<xsl:template match="class" /> 
	<xsl:template match="title" /> 
	<xsl:template match="error" />	 
	<xsl:template match="root/resourcesproperties" />	
	<xsl:template match="root/erreurs" /> 
	<xsl:template match="root/request" /> 
	<xsl:template match="root/session" /> 
	<xsl:template match="root/actionform" /> 
	<xsl:template match="root/variables" /> 
		
</xsl:stylesheet>