<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    
    <xsl:strip-space elements="*"/>
    <xsl:output method="xml" encoding="ISO-8859-1" standalone="yes" indent="no"/>
    
    <xsl:template match="/root/data">
        <DATA>
            <PARAMETERS>
                <xsl:for-each select="ParameterVO">
                    <PARAMETER>
                        <NAME><xsl:value-of select="name"/></NAME>
                        <LIBELLE><xsl:value-of select="prompt"/></LIBELLE>
                        <CURRENT_VALUE><xsl:value-of select="currentValue"/></CURRENT_VALUE>
                        <VALID_VALUE>
	                        <xsl:choose>
	                         <xsl:when test="currentValueValid='true'">TRUE</xsl:when>
	                         <xsl:otherwise>FALSE</xsl:otherwise>
	                        </xsl:choose>
	                    </VALID_VALUE>
                        <HELP><xsl:value-of select="helpText"/></HELP>
                        <HIDDEN><xsl:value-of select="hidden"/></HIDDEN>
                        <INPUT_TYPE><xsl:value-of select="inputType"/></INPUT_TYPE>
                        <ALLOWS_BLANK><xsl:value-of select="blankValueAllowed"/></ALLOWS_BLANK>
                        <ALLOWS_NULL><xsl:value-of select="nullValueAllowed"/></ALLOWS_NULL>
                        <xsl:for-each select="possibleValues">
                            <OPTIONS>
                                <xsl:for-each select="OptionVO">
                                    <OPTION>
                                        <LIBELLE><xsl:value-of select="libelle"/></LIBELLE>
                                        <VALUE><xsl:value-of select="value"/></VALUE>
                                        <SELECTED>
	                                        <xsl:choose>
		                                        <xsl:when test="selected='true'">TRUE</xsl:when>
		                                        <xsl:otherwise>FALSE</xsl:otherwise>
	                                        </xsl:choose>
                                        </SELECTED>
                                    </OPTION>
                                </xsl:for-each>
                            </OPTIONS>
                        </xsl:for-each>
                    </PARAMETER>
                </xsl:for-each>
            </PARAMETERS>
        </DATA>
    </xsl:template>
    
    
    <xsl:template match="resourcesproperties" /> 
    <xsl:template match="errors" /> 
    <xsl:template match="request" /> 
    <xsl:template match="session" /> 
    <xsl:template match="actionform" /> 
    <!--xsl:template match="variables" /--> 
</xsl:stylesheet>