package acube.gram.backend;

import javax.servlet.http.HttpServletRequest;

import acube.gram.exception.GramException;
import acube.gram.frontend.ActionHandler;
import acube.gram.frontend.ResourceHandler;

/**
 * Interface standard pour accder  un service de rapports.
 * Nota: dans la version complte de GRaM, avec gestion " chaud" des rapports, cette interface
 * contiendrai des mthodes pour grer les fichiers sur le serveur.
 * @author MAE
 */
public interface Backend {

	/**
	 * dfinit la cration d'url pour les actions
	 */
	public void setActionHandler(ActionHandler actionHandler)
		throws GramException;
	
	/**
	 * dfinit la cration d'url pour les ressources externes
	 */
	public void setResourceHandler(ResourceHandler resourceHandler)
		throws GramException;
	
	/*
	public List<FileMetadata> listFiles()
		throws GramException;

	public FileVO readFile(FileType type, String name)
		throws GramException;

	public void createFile(FileType type, String name, String contentType, byte[] definition)
		throws GramException;

	public void updateFile(FileType type, String name, String contentType, byte[] definition)
		throws GramException;

	public void deleteFile(FileType type, String name)
		throws GramException;
	*/


	/**
	 * Cre un context d'excution pour le rapport demand
	 * @param request la requte initiale
	 * @param path le chemin du rapport
	 * @return un nouveau contexte d'excution
	 */
	public ExecutionContext loadReport(HttpServletRequest request, String path)
		throws GramException;
}
