package acube.gram.backend;

import java.util.Collection;
import java.util.Map;

import acube.gram.constant.ReportFormat;
import acube.gram.exception.GramException;
import acube.gram.vo.FileVO;
import acube.gram.vo.ParameterVO;

/**
 * Interface qui encapsule un rapport en cours d'excution.
 * Il est typiquement stock en session.
 * @author MAE
 *
 */
public interface ExecutionContext {

	/**
	 * renvoie la liste des paramtres du rapport (avec les valeurs courantes)
	 * @return
	 * @throws GramException
	 */
	public Collection<ParameterVO> getParameters()
		throws GramException;

	/**
	 * dfinit certains paramtres 
	 * @param params le paramtres  dfinir
	 * @throws GramException
	 */
	public void setParameters(Map<String, String> params)
		throws GramException ;

	/**
	 * excute le rapport
	 * @param format le format attendu
	 * @return le rapport format
	 * @throws GramException
	 */
	public FileVO execute(ReportFormat format) 
		throws GramException;

	/**
	 * rpercute une action de type <i>drill-down</i>
	 * @param itemID l'identifiant de l'item sur lequel l'utilisateur a cliqu
	 * @throws GramException
	 */
	public void toggleItem(String itemID)
		throws GramException;
}
