package acube.gram.backend.birt;

import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;
import org.eclipse.birt.report.engine.api.HTMLImageHandler;
import org.eclipse.birt.report.engine.api.IImage;
import org.eclipse.birt.report.engine.api.script.IReportContext;

import acube.gram.exception.GramException;
import acube.gram.frontend.ResourceHandler;
import acube.gram.vo.FileVO;

public class GramHTMLImageHandler extends HTMLImageHandler {

	private Logger logger = Logger.getLogger(this.getClass());
	private String THIS_CLASS = "["+this.getClass().getName()+"] ";
	
	/**
	 * cl pour retrouver la session utilisateur dans le IReportContext
	 */
	public static final String CONTEXT_KEY_HTTP_SESSION = "acube.gram.backend.birt.HttpSession";
	
	/**
	 * le handler fourni par le frontend
	 */
	private ResourceHandler handler;

	
	public GramHTMLImageHandler(ResourceHandler handler) {
		super();
		this.handler = handler;
	}

	@Override
	public String onCustomImage(IImage image, IReportContext context) {

		return handleImage(image, context);
	}
	
	@Override
	public String onDesignImage(IImage image, IReportContext context) {

		return handleImage(image, context);
	}
	
	@Override
	public String onDocImage(IImage image, IReportContext context) {

		return handleImage(image, context);
	}
	
	@Override
	public String onFileImage(IImage image, IReportContext context) {

		return handleImage(image, context);
	}
	
	@Override
	public String onURLImage(IImage image, IReportContext context) {

		return handleImage(image, context);
	}
	
	private String handleImage(IImage image, IReportContext context) {
		
		// on rcupre la session
		HttpSession session = (HttpSession)context.getAppContext().get(CONTEXT_KEY_HTTP_SESSION);

		// on remplit un VO
		FileVO vo = new FileVO();
		vo.setContent(image.getImageData());
		vo.setContentType(image.getMimeType());

		// et on le passe au handler du frontend, qui renvoie une URL
		try {
			return handler.handleResource(session, vo);
		} catch (GramException e) {
			
			logger.error(THIS_CLASS+"GramException: "+e.getMessage());
			return null;
		}
	}
}
