package acube.gram.backend.ssrs;

import java.net.URL;

import acube.framework.vo.ErrorVO;
import acube.gram.exception.GramErrorCodes;
import acube.gram.exception.GramException;

import com.microsoft.schemas.sqlserver._2005._06._30.reporting.reportingservices.ReportExecutionServiceLocator;
import com.microsoft.schemas.sqlserver._2005._06._30.reporting.reportingservices.ReportExecutionServiceSoapStub;
import com.microsoft.schemas.sqlserver._2005._06._30.reporting.reportingservices.ReportingService2005Locator;
import com.microsoft.schemas.sqlserver._2005._06._30.reporting.reportingservices.ReportingService2005SoapStub;

/**
 * Classe pour crer des connexions au service web.
 * Pas de pool pour l'instant.
 * @author MAE
 *
 */
public class SOAPStubPool {

	/**
	 * url de base du web service
	 */
	private String url;

	/**
	 * url de base du web service
	 */
	private String user;

	/**
	 * url de base du web service
	 */
	private String password;

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getUser() {
		return user;
	}

	public void setUser(String login) {
		this.user = login;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public ReportExecutionServiceSoapStub getReportExecutionServiceSoapStub()
			throws GramException {

		try {
			ReportExecutionServiceLocator rsl = new ReportExecutionServiceLocator();
			ReportExecutionServiceSoapStub stub = new ReportExecutionServiceSoapStub(
					new URL(url + "/ReportExecution2005.asmx?"), rsl);

			stub.setUsername(user);
			stub.setPassword(password);
			return stub;

		} catch (Exception e) {
			ErrorVO erreur = new ErrorVO();
			erreur.setCdError(GramErrorCodes.UNKNOWN_ERROR); // TODO
			erreur.setParamLabel(e.getClass().getName());
			erreur.setParamNota(e.getMessage());
			throw new GramException(erreur);
		}
	}

	public ReportingService2005SoapStub getReportingService2005SoapStub()
			throws GramException {

		try {
			ReportingService2005Locator rsl = new ReportingService2005Locator();
			ReportingService2005SoapStub stub = new ReportingService2005SoapStub(
					new URL(url + "/ReportService2005.asmx?"), rsl);

			stub.setUsername(user);
			stub.setPassword(password);
			return stub;

		} catch (Exception e) {
			throw new GramException(""); // TODO
		}
	}
}
