package acube.gram.config;

import java.io.InputStream;

import javax.servlet.ServletException;

import org.apache.commons.digester.Digester;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.action.PlugIn;
import org.apache.struts.config.ModuleConfig;

import acube.gram.constant.AttributeKeys;

/**
 * Initialisation de GRaM
 * @author MAE
 *
 */
public class GramPlugin implements PlugIn {

	private String config;
	
	public void init(ActionServlet servlet, ModuleConfig moduleConfig) throws ServletException {
		
		Digester digester = new Digester();
		
		// pour rcuprer le rsultat
		GramPluginConfig gpConfig = new GramPluginConfig();
		digester.push(gpConfig);

		// configuration du delegate
		digester.addObjectCreate("gram-config/delegate", "acube.gram.business.impl.SimpleDelegate", "className");
		digester.addSetProperty("gram-config/delegate/set-property", "name", "value");
		digester.addSetNext("gram-config/delegate", "setDelegate");

		// configuration du backend
		digester.addObjectCreate("gram-config/delegate/backend", null, "className");
		digester.addSetProperty("gram-config/delegate/backend/set-property", "name", "value");
		digester.addSetNext("gram-config/delegate/backend", "setBackend");
		
		// configuration du ResourceHandler
		digester.addObjectCreate("gram-config/delegate/backend/resource-handler", null, "className");
		digester.addSetProperty("gram-config/delegate/backend/resource-handler/set-property", "name", "value");
		digester.addSetNext("gram-config/delegate/backend/resource-handler", "setResourceHandler");
		
		// configuration du ActionHandler
		digester.addObjectCreate("gram-config/delegate/backend/action-handler", null, "className");
		digester.addSetProperty("gram-config/delegate/backend/action-handler/set-property", "name", "value");
		digester.addSetNext("gram-config/delegate/backend/action-handler", "setActionHandler");

		// configuration des rapports
		digester.addObjectCreate("gram-config/delegate/reports/report", ReportConfig.class);
		digester.addSetProperties("gram-config/delegate/reports/report");
		digester.addSetNext("gram-config/delegate/reports/report", "addReport");
		
		try {
			// on lit la config
			InputStream is = servlet.getServletContext().getResourceAsStream(config);
			digester.parse(is);
			is.close();
			
		} catch (Exception e) {
			throw new ServletException("Configuration error : "+e.getLocalizedMessage());
		}

		// on met le delegate dans le ServletContext
		servlet.getServletContext().setAttribute(AttributeKeys.GRAM_DELEGATE, gpConfig.getDelegate());
	}
	
	public void destroy() {
		// nothing
	}

	public String getConfig() {
		return config;
	}

	public void setConfig(String config) {
		this.config = config;
	}
}
