package acube.gram.constant;

import acube.gram.exception.GramErrorCodes;
import acube.gram.exception.GramException;

/**
 * Encodage/dcodage des formats de rapports en String
 * @author MAE
 *
 */
public class ReportFormatCodec {

	public static String encode(ReportFormat format) {
		
		switch (format) {
		case PDF: return "PDF";
		case EXCEL: return "EXCEL";
		case HTML_FRAGMENT:  return "HTML_FRAGMENT";
		default:  return "HTML";
		}
	}

	public static ReportFormat decode(String format) throws GramException {
		
		if (format==null)
			return ReportFormat.HTML;
		
		if (format.equalsIgnoreCase("HTML_FRAGMENT"))
			return ReportFormat.HTML_FRAGMENT;
		
		if (format.equalsIgnoreCase("HTML"))
			return ReportFormat.HTML;
		
		if (format.equalsIgnoreCase("PDF"))
			return ReportFormat.PDF;

		if (format.equalsIgnoreCase("EXCEL"))
			return ReportFormat.EXCEL;
	
		throw new GramException(GramErrorCodes.INVALID_FORMAT);
	}
}
