package acube.gram.exception;

import acube.framework.vo.ErrorVO;

/**
 * Fonctions utilitaires pour crer des GramExceptions
 * @author MAE
 *
 */
public class GramExceptionFactory {
	
	public static GramException createServiceError(Exception e) {

		ErrorVO error = new ErrorVO();
		error.setCdError(GramErrorCodes.SERVICE_ERROR);
		error.setParamNota(e.getMessage());
		return new GramException(error);
	}
	
	public static GramException createUnknownError(Exception e) {

		ErrorVO error = new ErrorVO();
		error.setCdError(GramErrorCodes.UNKNOWN_ERROR);
		error.setParamLabel(e.getClass().getSimpleName());
		error.setParamNota(e.getMessage());
		return new GramException(error);
	}

	public static GramException createUnimplementedOperation(String operation) {

		ErrorVO error = new ErrorVO();
		error.setCdError(GramErrorCodes.UNIMPLEMENTED_OPERATION);
		error.setParamNota(operation);
		return new GramException(error);
	}

	public static GramException createConfigurationError(String error) {

		ErrorVO vo = new ErrorVO();
		vo.setCdError(GramErrorCodes.CONFIGURATION_ERROR);
		vo.setParamNota(error);
		return new GramException(vo);
	}
}
