package acube.gram.frontend;

import java.util.Map;

import acube.gram.constant.ReportFormat;
import acube.gram.exception.GramException;

/**
 * Cre des url pour les actions utilisateur en mode HTML.
 * L'objet est pass au backend, et ses mthodes sont appeles lors de la gnration du rapport.
 * @author MAE
 *
 */
public interface ActionHandler {
	
	/**
	 * Lien vers un autre rapport
	 * @param report le nom du rapport
	 * @param format le format attendu
	 * @param parameters les parametres
	 * @return une url qui affiche le rapport
	 * @throws GramException
	 */
	public String handleDrillThrough(String report, ReportFormat format, Map<String,String> parameters)
		throws GramException;

	/**
	 * Lien vers une URL "en dur"
	 * @param url
	 * @return
	 * @throws GramException
	 */
	public String handleHyperlink(String url)
		throws GramException;

	/**
	 * Action de type "afficher/cacher le dtail"
	 * @param itemID l'identifiant de l'objet
	 * @return
	 * @throws GramException
	 */
	public String handleDrillDown(String itemID)
		throws GramException;
}
