package acube.gram.frontend;

import javax.servlet.http.HttpSession;

import acube.gram.exception.GramException;
import acube.gram.vo.FileVO;

/**
 * cre des URL pour les ressources externes au rapport en mode HTML,
 * en particulier pour les images (logos, graphiques)
 * @author MAE
 *
 */
public interface ResourceHandler {

	/**
	 * cre une URL pour la ressource fournie. La ressource est typiquement stocke
	 * pour pouvoir tre rcupre par l'URL.
	 * @param session la session utilisateur
	 * @param vo la ressource, sous forme de FileVO
	 * @return une URl pour relire la ressource
	 */
	public String handleResource(HttpSession session, FileVO vo)
			throws GramException;

	/**
	 * renvoie une URL pour une image qui indique un lien pour afficher le dtail
	 * (typiquement, un "plus")
	 * @return
	 */
	public String handleTogglePlus()
		throws GramException;
	
	/**
	 * renvoie une URL pour une image qui indique un lien pour cacher le dtail
	 * (typiquement, un "moins")
	 * @return
	 */
	public String handleToggleMinus()
		throws GramException;
}
