package acube.gram.frontend.action;

import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import acube.framework.action.BaseAction;
import acube.framework.exception.AuthentificationException;
import acube.framework.exception.DAOException;
import acube.framework.exception.FunctionalException;
import acube.framework.exception.TechnicalException;
import acube.framework.technical.Constants;

/**
 * Rcriture de la BaseAction ACube qui permet d'accder  l'objet HttpServletResponse
 * pour crire des cookies.
 * TODO: rintgrer dans les standard ACube
 * @author MAE
 *
 */
public abstract class GramBaseAction extends BaseAction {
	
	@Override
	protected int getTypeOfFlux() {

		return Constants.TYPE_FLUX_XML;
	}
	
	@Override
	protected String getActivite() {

		return this.getClass().getName();
	}
	// Pour faire plaisir au FW ACube...
	@Override
	protected ArrayList<Serializable> getBeansActions(HttpServletRequest request) { return null; }
	
	// Les choses serieuses

	public ActionForward execute(ActionMapping mapping,
								 ActionForm form,
								 HttpServletRequest request,
								 HttpServletResponse response)
			throws IOException, DAOException, TechnicalException, FunctionalException {

		ArrayList<Serializable> beans = new ArrayList<Serializable>() ;
    	ArrayList<Serializable> errors = new ArrayList<Serializable>() ;

		executeAtStart(mapping, form, request, response, getActivite());
		response.setContentType("text/xml");
		
        try {
        	fillBeansActions(request,response,beans);
        	
    	} catch (TechnicalException e) {
    		logger.error("TechnicalException : "+ e.getMessage());
    		errors.add(e.getError());
    	} catch (FunctionalException e) {
    		logger.error("FunctionalException : "+ e.getMessage());
    		errors.add(e.getError());
    	} catch (AuthentificationException e) {
    		logger.error("AuthentificationException : "+ e.getMessage());
    		errors.add(e.getError());
    	}
    	
    	if ((beans==null) && (errors.isEmpty()))
    		return null;
    	

		ActionForward forward = mapping.findForward(Constants.FORWARD_SUCCESS);
		return executeAtEnd(mapping, form, request, response, forward, beans, errors, getTypeOfFlux());
	}
	
	
	protected abstract void fillBeansActions(HttpServletRequest request,
											 HttpServletResponse response,
											 List<Serializable> beans)
			throws AuthentificationException, TechnicalException, FunctionalException;
}
