package acube.gram.frontend.action.execution;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import acube.framework.exception.AuthentificationException;
import acube.framework.exception.FunctionalException;
import acube.framework.exception.TechnicalException;
import acube.gram.constant.AttributeKeys;
import acube.gram.frontend.action.FileBaseAction;
import acube.gram.frontend.action.ParameterAccessor;
import acube.gram.util.SimpleCache;
import acube.gram.vo.FileVO;

/**
 * Renvoie une ressource stocke dans le cache en session
 * @author MAE
 *
 */
public class GetResource extends FileBaseAction {

	protected FileVO getFileVO(HttpServletRequest request,
							   HttpServletResponse response)
			throws AuthentificationException, TechnicalException, FunctionalException {		
		
		// l'identifiant de la ressource
		String resourceID = ParameterAccessor.getResourceId(request);

		return (FileVO)SimpleCache.get(request.getSession(),
										AttributeKeys.RESOURCE_CACHE,
										resourceID);
	}
}
