package acube.gram.frontend.action.execution;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import acube.framework.exception.AuthentificationException;
import acube.framework.exception.FunctionalException;
import acube.framework.exception.TechnicalException;
import acube.gram.backend.ExecutionContext;
import acube.gram.business.Delegate;
import acube.gram.frontend.action.GramBaseAction;
import acube.gram.frontend.action.ParameterAccessor;

/**
 * Charge un rapport, renvoie ses paramtres et dfinit le cookie pour le contexte d'excution
 * @author MAE
 *
 */
public class Load extends GramBaseAction {

	@Override
	protected String getActivite() {

		return "acube.gram.frontend.action.execution.parameters";
	}
	
	protected void fillBeansActions(HttpServletRequest request,
									HttpServletResponse response,
									List<Serializable> beans)
			throws AuthentificationException, TechnicalException, FunctionalException {		
		
		Delegate delegate = ParameterAccessor.getDelegate(request);

		String report =
			ParameterAccessor.getReport(request);
		ExecutionContext context = delegate.loadReport(request,report);
		ParameterAccessor.setExecutionContext(request, response, context);

		Map<String, String> parameterValues =
			ParameterAccessor.getParameterValues(request);
		if (!parameterValues.isEmpty())
			context.setParameters(parameterValues);

		beans.addAll(context.getParameters());
	}
}
