package acube.gram.frontend.action.execution;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import acube.framework.exception.AuthentificationException;
import acube.framework.exception.FunctionalException;
import acube.framework.exception.TechnicalException;
import acube.gram.backend.ExecutionContext;
import acube.gram.business.Delegate;
import acube.gram.constant.ReportFormat;
import acube.gram.frontend.action.FileBaseAction;
import acube.gram.frontend.action.ParameterAccessor;
import acube.gram.vo.FileVO;

/**
 * Charge un rapport, dfinit ses paramtres et l'excute.
 * @author MAE
 *
 */
public class LoadAndRun extends FileBaseAction {

	protected FileVO getFileVO(HttpServletRequest request,
							   HttpServletResponse response)
			throws AuthentificationException, TechnicalException, FunctionalException {		
		
		Delegate delegate =
			ParameterAccessor.getDelegate(request);
		String report =
			ParameterAccessor.getReport(request);
		ExecutionContext context = delegate.loadReport(request,report);
		ParameterAccessor.setExecutionContext(request, response, context);

		Map<String, String> parameterValues =
			ParameterAccessor.getParameterValues(request);
		if (!parameterValues.isEmpty())
			context.setParameters(parameterValues);
		
		ReportFormat reportFormat =
			ParameterAccessor.getReportFormat(request);
		return context.execute(reportFormat);
	}
}
