package acube.gram.frontend.action.execution;

import java.io.Serializable;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import acube.framework.exception.AuthentificationException;
import acube.framework.exception.FunctionalException;
import acube.framework.exception.TechnicalException;
import acube.gram.backend.ExecutionContext;
import acube.gram.frontend.action.GramBaseAction;
import acube.gram.frontend.action.ParameterAccessor;

/**
 * Dfinit les paramtres d'un rapport, et renvoie la liste des paramtres mise  jour.
 * @author MAE
 *
 */
public class SetParameters extends GramBaseAction {

	@Override
	protected String getActivite() {

		return "acube.gram.frontend.action.execution.parameters";
	}

	protected void fillBeansActions(HttpServletRequest request,
									HttpServletResponse response,
									List<Serializable> beans)
			throws AuthentificationException, TechnicalException, FunctionalException {		
		
		ExecutionContext context = ParameterAccessor.getExecutionContext(request);
		context.setParameters(ParameterAccessor.getParameterValues(request));
		beans.addAll(context.getParameters());
	}
}
