package acube.gram.frontend.handlers;

import acube.gram.util.UrlWithParameters;

import java.util.HashMap;
import java.util.Map;

import acube.gram.constant.ReportFormat;
import acube.gram.constant.ReportFormatCodec;
import acube.gram.exception.GramException;
import acube.gram.frontend.ActionHandler;

/**
 * Implmentation des actions pour le client riche ACube 
 * (les url appellent des fonctions Javascript)
 * @author MAE
 *
 */
public class ACubeActionHandler implements ActionHandler {

	private String drillDown;
	private String drillThrough;
	
	public void setDrillDown(String drillDown) {
		this.drillDown = drillDown;
	}

	public void setDrillThrough(String drillThrough) {
		this.drillThrough = drillThrough;
	}

	public String handleDrillDown(String itemID) throws GramException {
		
		HashMap<String,String> params = new HashMap<String,String>();
		params.put("ID",itemID);
		return UrlWithParameters.replaceParameters(drillDown,params);
	}

	public String handleDrillThrough(String report, ReportFormat format, Map<String, String> parameters)
			throws GramException {

		Map<String,String> urlParams = new HashMap<String,String>();
		urlParams.put("REPORT",report);
		urlParams.put("FORMAT",ReportFormatCodec.encode(format));
		
		StringBuffer sb = new StringBuffer();
		sb.append("{ ");
		boolean first = true;
		for (Map.Entry<String,String> entry : parameters.entrySet()) {

			if (!first)
				sb.append(", ");
			first = false;
			
			String key = entry.getKey();
			String value = entry.getValue();

			sb.append(key);
			sb.append(":'");
			sb.append(value);
			sb.append("'");
		}
		sb.append(" }");
		urlParams.put("PARAMS",sb.toString());

		return UrlWithParameters.replaceParameters(drillThrough,urlParams);
	}

	public String handleHyperlink(String url) throws GramException {

		return url;
	}
}
