package acube.gram.frontend.handlers;

import acube.gram.util.UrlWithParameters;

import java.util.HashMap;
import java.util.Map;

import acube.gram.constant.ReportFormat;
import acube.gram.constant.ReportFormatCodec;
import acube.gram.exception.GramException;
import acube.gram.frontend.ActionHandler;

/**
 * Implmentation pour le client lger : les url font
 * directement rfrence aux actions du frontend.
 * @author MAE
 *
 */
public class SimpleActionHandler implements ActionHandler {

	private String drillDown;
	private String drillThrough;
	
	public void setDrillDown(String drillDown) {
		this.drillDown = drillDown;
	}

	public void setDrillThrough(String drillThrough) {
		this.drillThrough = drillThrough;
	}

	public String handleDrillDown(String itemID) throws GramException {
		
		HashMap<String,String> params = new HashMap<String,String>();
		params.put("ID",itemID);
		return UrlWithParameters.replaceParameters(drillDown,params);
	}

	public String handleDrillThrough(String report, ReportFormat format, Map<String, String> parameters)
			throws GramException {

		HashMap<String,String> params = new HashMap<String,String>();
		params.put("REPORT",report);
		params.put("FORMAT",ReportFormatCodec.encode(format));
		String baseUrl = UrlWithParameters.replaceParameters(drillThrough,params);

		StringBuffer sb = new StringBuffer();
		sb.append(baseUrl);
		for (Map.Entry<String,String> entry : parameters.entrySet()) {
			
			String key = entry.getKey();
			String value = entry.getValue();

			// on prfixe le nom par "_" pour qu'il soit reconnu comme parametre du rapport
			sb.append("&_"); 
			sb.append(key);
			sb.append("=");
			sb.append(value);
		}
		
		return sb.toString();
	}

	public String handleHyperlink(String url) throws GramException {

		return url;
	}
}
