package acube.gram.util;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import acube.gram.exception.GramErrorCodes;
import acube.gram.exception.GramException;

/**
 * Classe utilitaire pour grer les cookies
 * @author MAE
 *
 */
public class CookieWrapper {

	/**
	 * Lit un cookie dans une requte
	 * @param request la requte
	 * @param name le nom du cookie
	 * @return la valeur du cookies
	 * @throws GramException si le cookie n'est pas trouv
	 */
	public static String readCookie(HttpServletRequest request, String name)
			throws GramException {
		
		for (Cookie cookie : request.getCookies()) {
			if (cookie.getName().equals(name))
				return cookie.getValue();
		}
		throw new GramException(GramErrorCodes.MISSING_COOKIE);
	}

	/**
	 * Ajoute un cookie dans la rponse
	 * @param response la rponse
	 * @param path le chemin du cookie (URL de base)
	 * @param name son nom
	 * @param value sa valeur
	 * @throws GramException
	 */
	public static void setCookie(HttpServletResponse response, String path, String name, String value)
			throws GramException {

		Cookie cookie = new Cookie(name,value);
		cookie.setPath(path);
		response.addCookie(cookie);
	}
}
