package acube.gram.vo;

import java.io.Serializable;
import java.util.List;

/**
 * dfinition d'un paramtre de rapport pour le client riche ACube
 * @author MAE
 */
@SuppressWarnings("serial")
public class ParameterVO implements Serializable {

	/** l'identifiant du paramtre */
	private String name;
	/** le "prompt" */
	private String prompt;
	/** le texte d'aide */
	private String helpText;
	/** visibilit du champ (utile pour les paramtres prdfinis) */
	private boolean hidden;

	/** type de champ */
	private String inputType;
	/** type de donne attendu, n'importe lequel si null */
	private String dataType;
	/** indique si les donnes tapes doivent tre caches (mot de passe etc.) */
	private boolean secret;
	/** indique si la chane vide est accepte */
	private boolean blankValueAllowed;
	/** indique si le paramtre peut rester non dfini */
	private boolean nullValueAllowed;
	
	/** pour les paramtres de type liste, indique la liste des options */
	private List<OptionVO> possibleValues;
	/** valeur courante */
	private String currentValue;
	/** la valeur courante est-elle acceptable ? */
	private boolean currentValueValid;
	

	public String getName() {
		return name;
	}
	public void setName(String id) {
		this.name = id;
	}
	public String getPrompt() {
		return prompt;
	}
	public void setPrompt(String label) {
		this.prompt = label;
	}
	public String getHelpText() {
		return helpText;
	}
	public void setHelpText(String helpText) {
		this.helpText = helpText;
	}
	public boolean isHidden() {
		return hidden;
	}
	public void setHidden(boolean hidden) {
		this.hidden = hidden;
	}
	
	
	public String getDataType() {
		return dataType;
	}
	public void setDataType(String dataType) {
		this.dataType = dataType;
	}
	public String getInputType() {
		return inputType;
	}
	public void setInputType(String inputType) {
		this.inputType = inputType;
	}
	public boolean isSecret() {
		return secret;
	}
	public void setSecret(boolean secret) {
		this.secret = secret;
	}
	
	public boolean isBlankValueAllowed() {
		return blankValueAllowed;
	}
	public void setBlankValueAllowed(boolean allowBlankValue) {
		this.blankValueAllowed = allowBlankValue;
	}
	public boolean isNullValueAllowed() {
		return nullValueAllowed;
	}
	public void setNullValueAllowed(boolean allowNullValue) {
		this.nullValueAllowed = allowNullValue;
	}
	
	public String getCurrentValue() {
		return currentValue;
	}
	public void setCurrentValue(String defaultValue) {
		this.currentValue = defaultValue;
	}
	public boolean isCurrentValueValid() {
		return currentValueValid;
	}
	public void setCurrentValueValid(boolean currentValueValid) {
		this.currentValueValid = currentValueValid;
	}
	public List<OptionVO> getPossibleValues() {
		return possibleValues;
	}
	public void setPossibleValues(List<OptionVO> possibleValues) {
		this.possibleValues = possibleValues;
	}
}
