package acube.gram2.constant;

import acube.gram.exception.GramErrorCodes;
import acube.gram.exception.GramException;

/**
 * Encodage/dcodage de FileType en String
 * @author MAE
 *
 */
public class FileTypeCodec {

	private static final String SHARED_DATASOURCE = "SHARED_DATASOURCE";
	private static final String RESOURCE = "RESSOURCE";
	private static final String REPORT_DEFINITION = "RAPPORT";

	public static String encode(FileType format) {
		
		switch (format) {
		case REPORT_DEFINITION: return REPORT_DEFINITION;
		case RESOURCE:          return RESOURCE;
		case SHARED_DATASOURCE: return SHARED_DATASOURCE;
		default:                return null;
		}
	}

	public static FileType decode(String format) throws GramException {
		
		if (format==null)
			throw new GramException(GramErrorCodes.INVALID_FORMAT);
		
		if (format.equalsIgnoreCase(REPORT_DEFINITION))
			return FileType.REPORT_DEFINITION;
		
		if (format.equalsIgnoreCase(RESOURCE))
			return FileType.RESOURCE;

		if (format.equalsIgnoreCase(SHARED_DATASOURCE))
			return FileType.SHARED_DATASOURCE;
	
		throw new GramException(GramErrorCodes.INVALID_FORMAT);
	}
}
