package acube.gram2.integration;

import java.util.List;

import acube.framework.exception.JDBCWrapperException;
import acube.framework.exception.TechnicalException;
import acube.gram2.vo.NodeVO;
import acube.gram2.vo.ReportVO;
import acube.gram2.vo.RoleVO;

public interface DAO {

	public List<ReportVO> listReports()
		throws JDBCWrapperException, TechnicalException;

	public ReportVO getReportById(String path)
		throws JDBCWrapperException, TechnicalException;

	public void addReport(String path, String name)
		throws JDBCWrapperException, TechnicalException;

	public void updateReport(String path, String name)
		throws JDBCWrapperException, TechnicalException;

	public void deleteReport(String path)
		throws JDBCWrapperException, TechnicalException;

	public List<ReportVO> listReportsForNode(int id)
		throws JDBCWrapperException, TechnicalException;

	public void addReportToNode(int id, String report)
		throws JDBCWrapperException, TechnicalException;

	public void removeReportFromNode(int id, String report)
		throws JDBCWrapperException, TechnicalException;

	public void removeAllReportsFromNode(int id)
		throws JDBCWrapperException, TechnicalException;

	public void removeReportFromAllNodes(String path)
		throws JDBCWrapperException, TechnicalException;

	
	
	
	
	public List<NodeVO> listNodes()
		throws JDBCWrapperException, TechnicalException;

	public NodeVO getNodeById(int id)
		throws JDBCWrapperException, TechnicalException;

	public int addNode(Integer parent, String name)
		throws JDBCWrapperException, TechnicalException;

	public void updateNode(int id, String name)
		throws JDBCWrapperException, TechnicalException;

	public void deleteNode(int id)
		throws JDBCWrapperException, TechnicalException;

	
	
	
	
	public List<RoleVO> listRoles() 
		throws JDBCWrapperException, TechnicalException;

	public List<RoleVO> listRolesForReport(String path)
		throws JDBCWrapperException, TechnicalException;

	public void addRoleToReport(String path, String role)
		throws JDBCWrapperException, TechnicalException;

	public void removeRoleFromReport(String path, String role)
		throws JDBCWrapperException, TechnicalException;

	public void removeAllRolesFromReport(String path)
		throws JDBCWrapperException, TechnicalException;

}