var urlPage        = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/arborescence/arborescence.xml';
var urlPageEdition = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/arborescence/arborescencePourEdition.xml';

var urlInsert = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/arborescence/insert.xml';
var urlUpdate = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/arborescence/update.xml';
var urlDelete = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/arborescence/delete.xml';

function getParamDansUrl(name)
{
	var rg=new RegExp(name+"=([^&]*)");
	var r=rg.exec(document.location.search);
	return (r?unescape(r[1]):null);
}

var hote = getParamDansUrl("HOTE");
var edition = getParamDansUrl("EDITION");
var xmlPage;
var composantArborescence;

var champNom;
var champRapports;

function preparePage()
{
	var url;
	if (edition=="true")
		url = urlPageEdition;
	else
		url = urlPage;
	var callback = "window.frames['CONTENU_WIN'].construirePage";
	xmlPage = new parent.XMLObject(null,null,callback,url,false);
	xmlPage.initRequestParams("GET",{ HOTE:hote });
	xmlPage.importXML();
}

function construirePage()
{
	if (xmlPage.parseErrorXML() != 0)
		return;
		
	var elementArborescence = parent.getElements(xmlPage.xmlDoc,"ARBORESCENCE")[0];
	var xmlArborescence = new parent.XMLObjectSauvegarde();
	xmlArborescence.sauvegardeDOM(elementArborescence);
	composantArborescence = new ComposantArborescence("composantArborescence","navigation",xmlArborescence);
	composantArborescence.setDivBind(document.getElementById("composantArborescence"));
	composantArborescence.ecrireBind();
	
	

	// Formulaire
    composantFormulaire = new ComposantForm("composantFormulaire", "", "POST", 3, false);
        
	champNom      = creeElementFormText('nom',
							  { libelle:'Nom', maxLength:'150', size:'50' });
	champRapports = creeComposantRattachement('rapports',
								    { libelle:'Rapports', size:"6", width:"300px" });
	
	composantFormulaire.addElement(champNom);
	composantFormulaire.addElement(champRapports);
	
    boutonValider = new ElementFormButton("valider","javascript:validerFormulaire()","64px","18px",bouton_valider_src,bouton_validerover_src,bouton_validerdisabled_src,STATUT_ENABLED);
    boutonAnnuler = new ElementFormButton("annuler","javascript:afficheArborescence()","64px","18px",bouton_annuler_src,bouton_annulerover_src,bouton_annulerdisabled_src,STATUT_ENABLED);

    composantFormulaire.addElement(boutonAnnuler);
    composantFormulaire.addElement(boutonValider);
    
    composantFormulaire.ecrireBind();
    
    afficheArborescence();
}

function afficheArborescence()
{
	document.getElementById('composantArborescence').style.display = '';
	document.getElementById('composantFormulaire').style.display = 'none';
}

function afficheFormulaire()
{
	document.getElementById('composantArborescence').style.display = 'none';
	document.getElementById('composantFormulaire').style.display = '';
}

var idNoeud;
var mode;

function remplitFormulaire(id,nom,listeRapports) 
{
	champNom.setValue(nom);
	
	// edition des rapports
	var rapportsRattaches = listeRapports.split(',');
	var xmlOptions = parent.getElements(xmlPage.xmlDoc,"RAPPORT");
	var tabOption = [];
	for (var i=0; i<xmlOptions.length; i++)
	{
		var value = parent.getDataElement(xmlOptions[i],"CHEMIN");
		var libelle = parent.getDataElement(xmlOptions[i],"NOM");
		var selected = false;
		for (var j=0; j<rapportsRattaches.length; j++)
			if (value==rapportsRattaches[j])
			{
				selected = true;
				break;
			}
		tabOption.push(new ObjectOption(libelle,value,selected))
	}
	champRapports.setTabOption(tabOption);
	/////////////////////////////////////// BUG FRAMEWORK
	champRapports.select1.tabOption = champRapports.tabOptionNoSelected;
	champRapports.select2.tabOption = champRapports.tabOptionSelected;
	/////////////////////////////////////// BUG FRAMEWORK
    champRapports.ecrireBind();
}

function recupereValeursDansFormulaire()
{
	var params = {};
	params.HOTE = hote;
	params.NOM  = champNom.getValue();
			
	function listeDeValeurs(tabOption) {
		var txt = '';
		for (var i=0; i<tabOption.length; i++)
		{
			if (tabOption[i].selected)
			{
				if (txt!='')
					txt += ','
				txt += tabOption[i].value;
			}
		}
		return txt;
	}
	// liste des profils
	params.RAPPORTS = listeDeValeurs(champRapports.getTabOption());
		
	return params;
}

function validerFormulaire()
{
	var url;
	if (mode=='insert')
		url = urlInsert;
	else
		url = urlUpdate;

	var params = recupereValeursDansFormulaire();
	if (params==false)
		return;
	params.ID = idNoeud;
	
	executeActionServeur(url,params,preparePage);
}

function nouveauNoeud(idParent,nomParent)
{
	idNoeud = idParent;
	mode = 'insert';
	remplitFormulaire(null,'','');
	afficheFormulaire();
}

function modifierNoeud(id,nom,rapports)
{
	idNoeud = id;
	mode = 'update';
	remplitFormulaire(id,nom,rapports);
	afficheFormulaire();
}

function supprimerNoeud(id,nomNoeud)
{
	if (!confirm("Etes-vous s?r de vouloir supprimer le noeud '"+nomNoeud+"' et tous ses sous-noeuds ?"))
		return;
		
	// pas de valeurs saisies
	var params = { HOTE:hote, ID:id };	
	executeActionServeur(urlDelete,params,preparePage);
}