var urlPage   = '@PROJET_REPERTOIRE_INSTALL@/xml/gram/hotes/page.xml';
var urlListe  = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/hotes/liste.xml';
var urlInsert = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/hotes/insert.xml';
var urlUpdate = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/hotes/update.xml';
var urlDelete = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/hotes/delete.xml';

var xmlPage;
var composantTableau;

var champCode;
var champNom;
var champRacine;
var champType;
var champAdministrateur;
var champGestionnaire;

function preparePage()
{
	xmlPage = new parent.XMLObject(null, null, "window.frames['CONTENU_WIN'].construirePage", urlPage, false);
	xmlPage.importXML();
}

function construirePage()
{
    if (xmlPage.parseErrorXML() != 0)
    	return;
    
    var xmlInfosTableau = new parent.XMLObjectSauvegarde();
    xmlInfosTableau.sauvegardeDOM(parent.getElements(xmlPage.xmlDoc,"TABLEAU")[0]);
	composantTableau = new ComposantTableau("composantTableau", xmlInfosTableau,
											urlListe, true, false, false, true, false,"", false, true, false);
	composantTableau.ecrireBind();

	// Formulaire
    composantFormulaire = new ComposantForm("composantFormulaire", "", "POST", 3, false);
        
	champCode   = creeElementFormText('code',
							{ libelle:'Code', maxLength:'30', size:'50' });
	champNom    = creeElementFormText('nom',
							{ libelle:'Nom', maxLength:'255', size:'50' });
	champRacine = creeElementFormText('racine',
							{ libelle:'Racine sur le serveur', maxLength:'255', size:'50' });
	champType   = creeElementFormText('type',
							{ libelle:'Type Java', maxLength:'255', size:'50' });
	champAdministrateur = creeElementFormSelect('administrateur',  
							{ libelle:'Profil administrateur', width:'300px' });
	champGestionnaire   = creeElementFormSelect('gestionnaire',
							{ libelle:'Profil gestionnaire', width:'300px' });
	
	composantFormulaire.addElement(champCode);
	composantFormulaire.addElement(champNom);
	composantFormulaire.addElement(champRacine);
	composantFormulaire.addElement(champType);
	composantFormulaire.addElement(champAdministrateur);
	composantFormulaire.addElement(champGestionnaire);
	
    boutonValider = new ElementFormButton("valider","javascript:validerFormulaire()","64px","18px",bouton_valider_src,bouton_validerover_src,bouton_validerdisabled_src,STATUT_ENABLED);
    boutonAnnuler = new ElementFormButton("annuler","javascript:afficheTableau()","64px","18px",bouton_annuler_src,bouton_annulerover_src,bouton_annulerdisabled_src,STATUT_ENABLED);

    composantFormulaire.addElement(boutonAnnuler);
    composantFormulaire.addElement(boutonValider);
    
    composantFormulaire.ecrireBind();
    
    chargeTableau();
}


function chargeTableau()
{
	afficheTableau();
	composantTableau.importData();
}

function afficheTableau()
{
	document.getElementById('Position_composantTableau').style.display = '';
	document.getElementById('composantFormulaire').style.display = 'none';
}

function afficheFormulaire()
{
	document.getElementById('Position_composantTableau').style.display = 'none';
	document.getElementById('composantFormulaire').style.display = '';
}

var mode;

function remplitFormulaire(ligne) 
{
	champCode  .setValue(parent.getDataElement(ligne,'CODE'));
	champNom   .setValue(parent.getDataElement(ligne,'NOM'));
	champType  .setValue(parent.getDataElement(ligne,'TYPE'));
	champRacine.setValue(parent.getDataElement(ligne,'RACINE'));
	var administrateur = parent.getDataElement(ligne,'ADMINISTRATEUR');
	var gestionnaire   = parent.getDataElement(ligne,'GESTIONNAIRE');

	var listeProfils = parent.getElements(ligne,'LISTE_PROFILS')[0];
	var profils = parent.getElements(listeProfils,'PROFIL');
	var tabOptionAdministrateur = [];
	var tabOptionGestionnaire = [];

	tabOptionAdministrateur.push(new ObjectOption('(Aucun)','NULL',false));
	tabOptionGestionnaire.push(new ObjectOption('(Aucun)','NULL',false));
		
	for (var i=0; i<profils.length; i++)
	{
		var code = parent.getDataElement(profils[i],'CODE');
		var nom = parent.getDataElement(profils[i],'NOM');
		tabOptionAdministrateur.push(new ObjectOption(nom,code,(code==administrateur)));
		tabOptionGestionnaire.push(new ObjectOption(nom,code,(code==gestionnaire)));
	}
	
	champAdministrateur.setTabOption(tabOptionAdministrateur);
	champGestionnaire.setTabOption(tabOptionGestionnaire);
}

function videFormulaire(ligne) 
{
	var tabOptionAdministrateur = [];
	var tabOptionGestionnaire = [];
	tabOptionAdministrateur.push(new ObjectOption('(Aucun)','NULL',false));
	tabOptionGestionnaire.push(new ObjectOption('(Aucun)','NULL',false));

	champCode.setValue('');
	champNom.setValue('');
	champType.setValue('');
	champRacine.setValue('');
	champAdministrateur.setTabOption(tabOptionAdministrateur);
	champGestionnaire.setTabOption(tabOptionGestionnaire);
}

function controleFormat(maString,monFormat,msgObligatoire,msgFormat)
{
	if (msgObligatoire && (maString==''))
	{
		alert(msgObligatoire);
		return false;
	}
	if (!estFormatString(maString,monFormat))
	{
		alert(msgFormat);
		return false;
	}
	return true;
}

function recupereValeursDansFormulaire()
{
	var params = {};
	params.CODE = champCode.getValue();
	params.NOM = champNom.getValue();
	params.TYPE = champType.getValue();
	params.RACINE = champRacine.getValue();
	params.ADMINISTRATEUR = champAdministrateur.getValue();
	params.GESTIONNAIRE   = champGestionnaire.getValue();
	
	if (!controleFormat(params.CODE,'^[a-z_]{1,30}$','Le code est obligatoire','Le code doit ?tre une cha?ne en minuscules'))
		return false;
	if (!controleFormat(params.NOM,formatLibelle,'Le nom est obligatoire','Le nom doit ?tre une cha?ne'))
		return false;
	if (!controleFormat(params.TYPE,'^[a-zA-Z._]+$','Le type est obligatoire','Le type doit ?tre une classe Java'))
		return false;
	if (!controleFormat(params.RACINE,'^[a-zA-Z1-9_/]+$','La racine est obligatoire','La racine doit ?tre une cha?ne'))
		return false;
		
	return params;
}



function executeInsert()
{
	afficheFormulaire();
	mode = 'insert';
	videFormulaire();
}

function executeUpdate()
{
	afficheFormulaire();
	mode = 'update';
	
	var i = composantTableau.itemLigneAction;
	var ligne = parent.getElements(composantTableau.XMLData.xmlDoc,
                                   composantTableau.donneeLigne)[i];
	remplitFormulaire(ligne);
}

function validerFormulaire()
{
	var url;
	if (mode=='insert')
		url = urlInsert;
	else 
		url = urlUpdate;
	
	var params = recupereValeursDansFormulaire();
	if (params==false)
		return;

	executeActionServeur(url,params,chargeTableau);
}

function executeDelete(ligne,callback)
{
    var i = composantTableau.itemLigneAction;
    var ligne = parent.getElements(composantTableau.XMLData.xmlDoc,
                                   composantTableau.donneeLigne)[i];

	// pas de valeurs saisies
	var params = {};
	params.CODE = parent.getDataElement(ligne,"CODE");
	
	return executeActionServeur(urlDelete,params,chargeTableau);
}