var urlPage   = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/utilisateurs/page.xml';
var urlListe  = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/utilisateurs/liste.xml';
var urlInsert = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/utilisateurs/insert.xml';
var urlUpdate = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/utilisateurs/update.xml';
var urlDelete = '@PROJET_REPERTOIRE_INSTALL@/flux/protected/utilisateurs/delete.xml';

var xmlPage;
var composantTableau;

var champLogin;
var champNom;
var champProfils;

function preparePage()
{
	xmlPage = new parent.XMLObject(null, null, "window.frames['CONTENU_WIN'].construirePage", urlPage, false);
	xmlPage.importXML();
}

function construirePage()
{
    if (xmlPage.parseErrorXML() != 0)
    	return;
    
    var xmlInfosTableau = new parent.XMLObjectSauvegarde();
    xmlInfosTableau.sauvegardeDOM(parent.getElements(xmlPage.xmlDoc,"TABLEAU")[0]);
	composantTableau = new ComposantTableau("composantTableau", xmlInfosTableau,
											urlListe, true, false, false, true, false,"", false, true, false);
	composantTableau.ecrireBind();

	// Formulaire
    composantFormulaire = new ComposantForm("composantFormulaire", "", "POST", 3, false);
        
	champLogin   = creeElementFormText('login',
							 { libelle:'Identifiant', maxLength:'30', size:'50' });
	champNom     = creeElementFormText('nom',
							 { libelle:'Nom', maxLength:'255', size:'50' });
	champProfils = creeComposantRattachement('profils',
								   { libelle:'profils', size:"6", width:"300px" });
	
	composantFormulaire.addElement(champLogin);
	composantFormulaire.addElement(champNom);
	composantFormulaire.addElement(champProfils);
	
    boutonValider = new ElementFormButton("valider","javascript:validerFormulaire()","64px","18px",bouton_valider_src,bouton_validerover_src,bouton_validerdisabled_src,STATUT_ENABLED);
    boutonAnnuler = new ElementFormButton("annuler","javascript:afficheTableau()","64px","18px",bouton_annuler_src,bouton_annulerover_src,bouton_annulerdisabled_src,STATUT_ENABLED);

    composantFormulaire.addElement(boutonAnnuler);
    composantFormulaire.addElement(boutonValider);
    
    composantFormulaire.ecrireBind();
    
    chargeTableau();
}


function chargeTableau()
{
	afficheTableau();
	composantTableau.importData();
}

function afficheTableau()
{
	document.getElementById('Position_composantTableau').style.display = '';
	document.getElementById('composantFormulaire').style.display = 'none';
}

function afficheFormulaire()
{
	document.getElementById('Position_composantTableau').style.display = 'none';
	document.getElementById('composantFormulaire').style.display = '';
}

var mode;

function remplitFormulaire(ligne) 
{
	champLogin.setValue(parent.getDataElement(ligne,'LOGIN'));
	champNom  .setValue(parent.getDataElement(ligne,'NOM'));
	
    var xmlData = new parent.XMLObjectSauvegarde();
    xmlData.sauvegardeDOM(parent.getElements(ligne,"PROFILS")[0]);
    champProfils.setXmlData(xmlData);
    champProfils.ecrireBind();
}

function videFormulaire(ligne) 
{
	champLogin.setValue('');
	champNom  .setValue('');

    var xmlData = new parent.XMLObjectSauvegarde();
    xmlData.sauvegardeDOM(parent.getElements(xmlPage.xmlDoc,"RATTACHEMENT_VIDE")[0]);
    champProfils.setXmlData(xmlData);
    champProfils.ecrireBind();
}

function controleFormat(maString,monFormat,msgObligatoire,msgFormat)
{
	if (msgObligatoire && (maString==''))
	{
		alert(msgObligatoire);
		return false;
	}
	if (!estFormatString(maString,monFormat))
	{
		alert(msgFormat);
		return false;
	}
	return true;
}

function recupereValeursDansFormulaire()
{
	var params = {};
	params.LOGIN = champLogin.getValue();
	params.NOM   = champNom.getValue();
	
	if (!controleFormat(params.LOGIN,'^[a-zA-Z1-9-/]+$','L\'identifiant est obligatoire','L\'identifiant doit ?tre une cha?ne sans caract?res sp?ciaux'))
		return false;
	if (params.NOM=='')
	{
	    alert('Le nom est obligatoire')
		return false;
	}
		
	function listeDeValeurs(tabOption) {
		var txt = '';
		for (var i=0; i<tabOption.length; i++)
		{
			if (tabOption[i].selected)
			{
				if (txt!='')
					txt += ','
				txt += tabOption[i].value;
			}
		}
		return txt;
	}
	// liste des profils
	params.PROFILS = listeDeValeurs(champProfils.getTabOption());
		
	return params;
}



function executeInsert()
{
	afficheFormulaire();
	mode = 'insert';
	videFormulaire();
}

function executeUpdate()
{
	afficheFormulaire();
	mode = 'update';
	
	var i = composantTableau.itemLigneAction;
	var ligne = parent.getElements(composantTableau.XMLData.xmlDoc,
                                   composantTableau.donneeLigne)[i];
	remplitFormulaire(ligne);
}

function validerFormulaire()
{
	var url;
	if (mode=='insert')
		url = urlInsert;
	else 
		url = urlUpdate;
	
	var params = recupereValeursDansFormulaire();
	if (params==false)
		return;

	executeActionServeur(url,params,chargeTableau);
}

function executeDelete(ligne,callback)
{
    var i = composantTableau.itemLigneAction;
    var ligne = parent.getElements(composantTableau.XMLData.xmlDoc,
                                   composantTableau.donneeLigne)[i];

	// pas de valeurs saisies
	var params = {};
	params.LOGIN = parent.getDataElement(ligne,"LOGIN");
	
	return executeActionServeur(urlDelete,params,chargeTableau);
}